{ $RCSfile: FOptions.pas,v $ $Revision: 1.6 $ $Date: 2004/03/22 05:27:35 $ $Author: vlads $ }
{                                                                                    }
{ ================================================================================== }
{                                                                                    }
{   This file is part of winKeyLock,  http://winKeyLock.sourceforge.net/             }
{   See readme.txt and license.txt for details.                                      }
{   (c) Copyright 2004 - Vlad Skarzhevskyy & co                                      }
{                                                                                    }
{   This program is free software; you can redistribute it and/or modify it under    }
{  the terms of the GNU General Public License as published by the Free Software     }
{  Foundation; either version 2 of the License, or (at your option) any later        }
{  version.                                                                          }
{                                                                                    }
{   This program is distributed in the hope that it will be useful, but WITHOUT ANY  }
{  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A   }
{  PARTICULAR PURPOSE.  See the GNU General Public License for more details.         }
{                                                                                    }
{  The GNU GPL can be found at:       http://www.gnu.org/copyleft/gpl.html           }
{                                                                                    }
{ ================================================================================== }

unit FOptions;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ActnList, ImgList, ExtCtrls, Buttons, Menus;

type
  TFormOptions = class(TForm)
    PageControl: TPageControl;
    tsGeneral: TTabSheet;
    tsHotKeys: TTabSheet;
    cbStartUp: TCheckBox;
    HotKeyLock: THotKey;
    lHotKeyLock: TLabel;
    lHotKeyUnLock: TLabel;
    HotKeyUnLock: THotKey;
    cbExplorer: TCheckBox;
    cbDesktop: TCheckBox;
    StatusBar: TStatusBar;
    PanelButtons: TPanel;
    ActionList: TActionList;
    acCancel: TAction;
    acApply: TAction;
    BitBtnApply: TBitBtn;
    BitBtnCancel: TBitBtn;
    tsLock: TTabSheet;
    cbMouseMove: TCheckBox;
    cbMouseButtons: TCheckBox;
    cmMouseWheel: TCheckBox;
    cbKeyboard: TCheckBox;
    cbScreenSaverOff: TCheckBox;
    acLockNow: TAction;
    BitBtnLockNow: TBitBtn;
    cbBeep: TCheckBox;
    ImageList: TImageList;
    TabSheetIcons: TTabSheet;
    lImageLocked: TLabel;
    ImageLocked: TImage;
    UpDownLocked: TUpDown;
    lImageUnLocked: TLabel;
    ImageUnLocked: TImage;
    UpDownUnLocked: TUpDown;
    ListViewImage: TListView;
    PopupMenuUnLocked: TPopupMenu;
    PopupMenuLocked: TPopupMenu;
    TabSheetAbout: TTabSheet;
    ImageLogo: TImage;
    lblHomepage: TLabel;
    LabelHomePage: TLabel;
    LabelCopyright: TLabel;
    LabelGPL: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure acCancelExecute(Sender: TObject);
    procedure acApplyExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure acLockNowExecute(Sender: TObject);
    procedure UpDownLockedClick(Sender: TObject; Button: TUDBtnType);
    procedure UpDownUnLockedClick(Sender: TObject; Button: TUDBtnType);
    procedure ImageLockedClick(Sender: TObject);
    procedure ImageUnLockedClick(Sender: TObject);
    procedure lblHomepageMouseEnter(Sender: TObject);
    procedure lblHomepageMouseLeave(Sender: TObject);
    procedure lblHomepageClick(Sender: TObject);
    procedure LabelGPLClick(Sender: TObject);
  protected
    procedure CreateParams(Var Params: TCreateParams); override;    
  private
    cImgLockedIdx : integer;
    cImgUnLockedIdx : integer;
    { Private declarations }
    procedure SetLockedIdx(idx: integer);
    procedure SetUnLockedIdx(idx: integer);
    procedure ShowSettings();
    procedure StoreSettings();
    procedure StatusBarShowHint(Sender: TObject);
    procedure ShowListView();
    procedure OnPmiLockedClick(Sender: TObject);
    procedure OnPmiUnLockedClick(Sender: TObject);
  public
    { Public declarations }
  end;

  function ForceForeground(AppHandle: HWND): boolean;
  
var
  FormOptions: TFormOptions;

implementation

uses
    ShellApi,
    Properties,
    FwinKeyLockMain;

{$R *.dfm}

function ForceForeground(AppHandle:HWND): boolean;
const
SPI_GETFOREGROUNDLOCKTIMEOUT = $2000;
SPI_SETFOREGROUNDLOCKTIMEOUT = $2001;
var
ForegroundThreadID: DWORD;
ThisThreadID      : DWORD;
timeout           : DWORD;
OSVersionInfo     : TOSVersionInfo;
Win32Platform     : Integer;
begin
if IsIconic(AppHandle) then ShowWindow(AppHandle, SW_RESTORE);
if (GetForegroundWindow = AppHandle) then Result := true else
begin
  Win32Platform := 0;
  OSVersionInfo.dwOSVersionInfoSize := SizeOf(OSVersionInfo);
  if GetVersionEx(OSVersionInfo) then Win32Platform := OSVersionInfo.dwPlatformId;

  { Windows 98/2000 doesn't want to foreground a window when some other window has keyboard focus}

  if ((Win32Platform = VER_PLATFORM_WIN32_NT) and (OSVersionInfo.dwMajorVersion > 4)) or
     ((Win32Platform = VER_PLATFORM_WIN32_WINDOWS) and ((OSVersionInfo.dwMajorVersion > 4) or
     ((OSVersionInfo.dwMajorVersion = 4) and (OSVersionInfo.dwMinorVersion > 0)))) then
  begin
    Result := false;
    ForegroundThreadID := GetWindowThreadProcessID(GetForegroundWindow,nil);
    ThisThreadID := GetWindowThreadPRocessId(AppHandle,nil);
    if AttachThreadInput(ThisThreadID, ForegroundThreadID, true) then
    begin
      BringWindowToTop(AppHandle);
      SetForegroundWindow(AppHandle);
      AttachThreadInput(ThisThreadID, ForegroundThreadID, false);
      Result := (GetForegroundWindow = AppHandle);
    end;
    if not Result then
    begin
      SystemParametersInfo(SPI_GETFOREGROUNDLOCKTIMEOUT, 0, @timeout, 0);
      SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, TObject(0), SPIF_SENDCHANGE);
      BringWindowToTop(AppHandle);
      SetForegroundWindow(AppHandle);
{$WARNINGS OFF}
      SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, TObject(timeout), SPIF_SENDCHANGE);
{$WARNINGS ON}
      Result := (GetForegroundWindow = AppHandle);
      if not Result then
        begin
        ShowWindow(AppHandle,SW_HIDE);
        ShowWindow(AppHandle,SW_SHOWMINIMIZED);
        ShowWindow(AppHandle,SW_SHOWNORMAL);
        BringWindowToTop(AppHandle);
        SetForegroundWindow(AppHandle);
        end;
    end;
  end else
  begin
    BringWindowToTop(AppHandle);
    SetForegroundWindow(AppHandle);
  end;
  Result := (GetForegroundWindow = AppHandle);
end;
end;


procedure TFormOptions.FormCreate(Sender: TObject);
begin
    ModalResult := mrNone;
    Application.OnHint := StatusBarShowHint;
    ShowSettings;
end;

procedure TFormOptions.CreateParams(var Params: TCreateParams);
begin
  inherited;
  //Params.Style := Params.Style and not WS_CAPTION or WS_POPUP;
  //Params.ExStyle := Params.ExStyle or WS_EX_TOOLWINDOW;
end;

procedure TFormOptions.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    Application.OnHint := nil;
    Action := caFree;
end;

procedure TFormOptions.acCancelExecute(Sender: TObject);
begin
    Close;
end;

procedure TFormOptions.acLockNowExecute(Sender: TObject);
begin
    acApply.Execute();
    if (ModalResult = mrOk) then
        ModalResult := mrYes;
end;

procedure TFormOptions.acApplyExecute(Sender: TObject);
begin
    if (cbKeyboard.Checked and
        (cbMouseMove.Checked or
         cbMouseButtons.Checked) and
        (HotKeyUnLock.HotKey = 0)) then
    begin
        Application.MessageBox('Need UnLock HotKey!',
                               'Invalid configuration', MB_OK);
        ModalResult := mrNone;
        Exit;
    end;
    StoreSettings;
    Close;
    ModalResult := mrOk;
end;

procedure TFormOptions.ShowSettings;
begin
    cbKeyboard.Checked := IniFile.LockSettings.asBoolean[WKL_PROP_LOCK_KEYBOARD];
    cbMouseMove.Checked := IniFile.LockSettings.asBoolean[WKL_PROP_LOCK_MOUSE_MOVE];
    cbMouseButtons.Checked := IniFile.LockSettings.asBoolean[WKL_PROP_LOCK_MOUSE_BTN];
    cmMouseWheel.Checked := IniFile.LockSettings.asBoolean[WKL_PROP_LOCK_MOUSE_WHEEL];

    cbMouseMove.Enabled := (Win32Platform = VER_PLATFORM_WIN32_NT);
    cbMouseButtons.Enabled := cbMouseMove.Enabled;
    cmMouseWheel.Enabled := cbMouseMove.Enabled;

    HotKeyLock.HotKey := IniFile.LockSettings.values[WKL_PROP_KEY_LOCK];
    HotKeyUnLock.HotKey := IniFile.LockSettings.values[WKL_PROP_KEY_UNLOCK];

    cbScreenSaverOff.Checked := IniFile.LockSettings.asBoolean[WKL_PROP_SCREEN_SAVER_OFF];
    cbBeep.Checked := IniFile.LockSettings.asBoolean[WKL_PROP_DO_BEEP];

    ShowListView();
    SetLockedIdx(IniFile.LockSettings.values[WKL_PROP_LOKED_IDX]);
    SetUnLockedIdx(IniFile.LockSettings.values[WKL_PROP_UNLOKED_IDX]);
end;

procedure TFormOptions.StoreSettings;
begin
    IniFile.LockSettings.asBoolean[WKL_PROP_LOCK_KEYBOARD] := cbKeyboard.Checked;
    IniFile.LockSettings.asBoolean[WKL_PROP_LOCK_MOUSE_MOVE] := cbMouseMove.Checked;
    IniFile.LockSettings.asBoolean[WKL_PROP_LOCK_MOUSE_BTN] := cbMouseButtons.Checked;
    IniFile.LockSettings.asBoolean[WKL_PROP_LOCK_MOUSE_WHEEL] := cmMouseWheel.Checked;

    IniFile.LockSettings.values[WKL_PROP_KEY_LOCK] := HotKeyLock.HotKey;
    IniFile.LockSettings.values[WKL_PROP_KEY_UNLOCK] := HotKeyUnLock.HotKey;

    IniFile.LockSettings.asBoolean[WKL_PROP_SCREEN_SAVER_OFF] := cbScreenSaverOff.Checked;
    IniFile.LockSettings.asBoolean[WKL_PROP_DO_BEEP] := cbBeep.Checked;

    IniFile.LockSettings.values[WKL_PROP_LOKED_IDX] := cImgLockedIdx;
    IniFile.LockSettings.values[WKL_PROP_UNLOKED_IDX] := cImgUnLockedIdx;
end;

procedure TFormOptions.StatusBarShowHint(Sender: TObject);
begin
    StatusBar.SimpleText := Application.Hint;
end;

procedure TFormOptions.UpDownLockedClick(Sender: TObject; Button: TUDBtnType);
begin
    if (Button = btNext ) then
        Inc(cImgLockedIdx)
    else
        Dec(cImgLockedIdx);

    SetLockedIdx(cImgLockedIdx);
end;

procedure TFormOptions.SetLockedIdx(idx: integer);
var
    b : TBitmap;
begin
    cImgLockedIdx := idx;
    if (cImgLockedIdx < 0) then cImgLockedIdx := 0;
    if (cImgLockedIdx >= FormWinKeyLockMain.ImageList.Count) then
        cImgLockedIdx := FormWinKeyLockMain.ImageList.Count - 1;

    b := TBitmap.Create;
    FormWinKeyLockMain.ImageList.GetBitmap(cImgLockedIdx, b);
    ImageLocked.Picture.Bitmap.Assign(b);
    b.Free;
    UpDownLocked.Position := cImgLockedIdx;
    UpDownLocked.Max := FormWinKeyLockMain.ImageList.Count - 1;
end;

procedure TFormOptions.UpDownUnLockedClick(Sender: TObject;
  Button: TUDBtnType);
begin
    if (Button = btNext ) then
        Inc(cImgUnLockedIdx)
    else
        Dec(cImgUnLockedIdx);

    SetUnLockedIdx(cImgUnLockedIdx);
end;

procedure TFormOptions.SetUnLockedIdx(idx: integer);
var
    b : TBitmap;
begin
    cImgUnLockedIdx := idx;
    if (cImgUnLockedIdx < 0) then cImgUnLockedIdx := 0;
    if (cImgUnLockedIdx >= FormWinKeyLockMain.ImageList.Count) then
        cImgUnLockedIdx := FormWinKeyLockMain.ImageList.Count - 1;

    b := TBitmap.Create;
    FormWinKeyLockMain.ImageList.GetBitmap(cImgUnLockedIdx, b);
    ImageUnLocked.Picture.Bitmap.Assign(b);
    b.Free;
    UpDownUnLocked.Position := cImgUnLockedIdx;
    UpDownUnLocked.Max := FormWinKeyLockMain.ImageList.Count - 1;
end;

procedure TFormOptions.ShowListView;
var
    i : integer;
    item: TListItem;
    NewItem: TMenuItem;
begin
    ListViewImage.LargeImages := FormWinKeyLockMain.ImageList;
    ListViewImage.SmallImages := FormWinKeyLockMain.ImageList;
    PopupMenuUnLocked.Images := FormWinKeyLockMain.ImageList;
    PopupMenuLocked.Images := FormWinKeyLockMain.ImageList;
    for i := 0  to FormWinKeyLockMain.ImageList.Count - 1 do
    begin
        item := ListViewImage.Items.Add;
        item.ImageIndex := i;

        NewItem := TMenuItem.Create(PopupMenuUnLocked);
        NewItem.Caption := '';
        NewItem.ImageIndex := i;
        NewItem.Tag := i;
        NewItem.OnClick := OnPmiUnLockedClick;
        PopupMenuUnLocked.Items.Add(NewItem);

        NewItem := TMenuItem.Create(PopupMenuLocked);
        NewItem.Caption := '';
        NewItem.ImageIndex := i;
        NewItem.Tag := i;
        NewItem.OnClick := OnPmiLockedClick;
        PopupMenuLocked.Items.Add(NewItem);
    end;
end;

procedure TFormOptions.ImageLockedClick(Sender: TObject);
var
    Point: TPoint;
begin
    Point.X := ImageLocked.Width div 2;
    Point.Y := ImageLocked.Height div 2;
    Point := ImageLocked.ClientToScreen(Point);
    PopupMenuLocked.Popup(Point.X, Point.Y);
end;

procedure TFormOptions.ImageUnLockedClick(Sender: TObject);
var
    Point: TPoint;
begin
    Point.X := ImageUnLocked.Width div 2;
    Point.Y := ImageUnLocked.Height div 2;
    Point := ImageUnLocked.ClientToScreen(Point);
    PopupMenuUnLocked.Popup(Point.X, Point.Y);

end;

procedure TFormOptions.OnPmiLockedClick(Sender: TObject);
begin
   SetLockedIdx((Sender as TMenuItem).Tag);
end;

procedure TFormOptions.OnPmiUnLockedClick(Sender: TObject);
begin
    SetUnLockedIdx((Sender as TMenuItem).Tag);
end;

procedure TFormOptions.lblHomepageMouseEnter(Sender: TObject);
begin
    (Sender as TLabel).Font.Style := [fsUnderline];
end;

procedure TFormOptions.lblHomepageMouseLeave(Sender: TObject);
begin
    (Sender as TLabel).Font.Style := [];
end;

procedure TFormOptions.lblHomepageClick(Sender: TObject);
begin
    ShellExecute(0, 'open',
                PChar('http://winkeylock.sourceforge.net/'),
                PChar(''), PChar(''), SW_RESTORE);
end;

procedure TFormOptions.LabelGPLClick(Sender: TObject);
begin
    ShellExecute(0, 'open',
                PChar('http://www.gnu.org/licenses/gpl.html'),
                PChar(''), PChar(''), SW_RESTORE);
end;

end.
