{ $RCSfile: FPopup.pas,v $ $Revision: 1.3 $ $Date: 2004/03/22 05:27:35 $ $Author: vlads $ }
{                                                                                    }
{ ================================================================================== }
{                                                                                    }
{   This file is part of winKeyLock,  http://winKeyLock.sourceforge.net/             }
{   See readme.txt and license.txt for details.                                      }
{   (c) Copyright 2004 - Vlad Skarzhevskyy & co                                      }
{                                                                                    }
{   This program is free software; you can redistribute it and/or modify it under    }
{  the terms of the GNU General Public License as published by the Free Software     }
{  Foundation; either version 2 of the License, or (at your option) any later        }
{  version.                                                                          }
{                                                                                    }
{   This program is distributed in the hope that it will be useful, but WITHOUT ANY  }
{  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A   }
{  PARTICULAR PURPOSE.  See the GNU General Public License for more details.         }
{                                                                                    }
{  The GNU GPL can be found at:       http://www.gnu.org/copyleft/gpl.html           }
{                                                                                    }
{ ================================================================================== }

unit FPopup;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TFormPopup = class(TForm)
    ImageClose: TImage;
    LabelMessage: TLabel;
    GroupBoxTitle: TGroupBox;
    TimerClose: TTimer;
    Image: TImage;
    procedure ImageCloseClick(Sender: TObject);
    procedure TimerCloseTimer(Sender: TObject);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormDeactivate(Sender: TObject);
    procedure ImageContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
  protected
    procedure CreateParams(Var Params: TCreateParams); override;
  private
    { Private declarations }
  public
    { Public declarations }
     procedure AdjustPosition();
     class procedure BalloonHint(Title, Value: string; Delay: Integer; icon :TIcon);
  end;

var
  FormPopup: TFormPopup;

implementation

{$R *.dfm}

uses
    Properties, FwinKeyLockMain;

procedure TFormPopup.AdjustPosition;
begin
    Left := Screen.WorkAreaLeft + Screen.WorkAreaWidth - Width - 16;
    Top := Screen.WorkAreaTop + Screen.WorkAreaHeight - Height - 4;
    ImageClose.Left := ClientWidth - 5 - 13;
    ImageClose.Top := 1;
    ImageClose.BringToFront;
    Image.Width := 16;
    Image.Height := 16;
    GroupBoxTitle.Height := Image.Top + Image.Height + 5;
end;

procedure AssignGraphic(aBitmap: TBitmap; Icon: TIcon);
var
    vBitmap: TBitmap;
begin
    Icon.Handle; // GetHandle
    vBitmap := TBitmap.Create;
    vBitmap.Width := Icon.Width;
    vBitmap.Height := Icon.Height;
    vBitmap.Canvas.CopyMode := cmSrcCopy;
    vBitmap.Canvas.Draw(0, 0, Icon);
    aBitmap.Assign(vBitmap);
    vBitmap.Free;
end;

class procedure TFormPopup.BalloonHint(Title, Value: string;
                                       Delay: Integer; Icon: TIcon);
begin
    if (FormPopup = nil) then
        FormPopup := TFormPopup.Create(FormWinKeyLockMain);

    FormPopup.GroupBoxTitle.Caption := Title;
    FormPopup.LabelMessage.Caption := Value;
    AssignGraphic(FormPopup.Image.Picture.Bitmap, Icon);
    FormPopup.AdjustPosition;
    FormPopup.Show();
    FormPopup.TimerClose.Enabled := false;
    FormPopup.TimerClose.Enabled := true;
    FormPopup.TimerClose.Interval := Delay;
end;

procedure TFormPopup.CreateParams(var Params: TCreateParams);
const
  CS_DROPSHADOW = $00020000;
begin
  inherited;
  Params.Style := Params.Style and not WS_CAPTION or WS_POPUP;
  Params.ExStyle := Params.ExStyle or WS_EX_TOOLWINDOW or WS_EX_NOACTIVATE;
  If (IsWinXP) Then
    Params.WindowClass.Style := Params.WindowClass.Style or CS_DROPSHADOW;
end;

procedure TFormPopup.ImageCloseClick(Sender: TObject);
begin
    Close;
end;

procedure TFormPopup.TimerCloseTimer(Sender: TObject);
begin
    TimerClose.Enabled := false;
    Close;
end;

procedure TFormPopup.FormMouseUp(Sender: TObject; Button: TMouseButton;
                                Shift: TShiftState; X, Y: Integer);
begin
    Close;
end;

procedure TFormPopup.FormDeactivate(Sender: TObject);
begin
    if Self.Visible then
        Close;
end;

procedure TFormPopup.ImageContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
begin
    Close;
    FormWinKeyLockMain.acOptions.Execute();
    Handled := true;
end;

end.
