# $Id: makefile.mak,v 1.2 2004/03/22 04:17:41 vlads Exp $
#
# Makefile for winKeyLockHook.dll
#
# You should run this using 'make -f makefile.mak dll' from the
# DLL src directory (for instance, C:\projects\mp3bookhelper\current\C-DLL\winKeyLockHook).
#

SRCDIR=.
OBJDIR=obj
OUTDIR=obj

DLL_TARGET=winKeyLockHook.dll

CC=cl.exe

# /W   Warning Level
# /MD  Multithreaded DLL
# /MT  Multithreaded
# /O2  Maximize Speed

CFLAGS=-nologo -I. /O1 -W3 \
       -DWIN32 -D_WINDOWS -DNDEBUG -DwinKeyLockHook_DLL_EXPORTS -D_USRDLL -D_WIN32_WINNT=0x0501

RSC=rc.exe
RSC_PROJ=/l 0x1009 /d "NDEBUG"

LINK=link.exe

LINK_FLAGS=/DEFAULTLIB:user32.lib advapi32.lib -nologo -machine:I386 -incremental:no /SUBSYSTEM:WINDOWS /OPT:NOREF \
           -dll  /RELEASE /def:"$(SRCDIR)\winKeyLockHook.def" \
           -LIBPATH:$(OBJDIR)

SRCS=winKeyLockHook.c

SRCS_RC=winKeyLockHook.rc

#The .path.ext directive tells MAKE where to look for files with a certain extension.
.path.c = $(SRCDIR)
.path.cpp = $(SRCDIR)
.path.obj = $(OBJDIR)

OBJS = $(SRCS:.c=.obj)

LINK_OBJS=$(OBJS) $(SRCS_RC:.rc=.res)

OUTDIR :
    @if not exist "$(OUTDIR)" mkdir "$(OUTDIR)"

CLEAN :
    @echo Clean
	-@erase /Q "$(OBJDIR)\*.obj"
	-@erase /Q "$(OUTDIR)\$(DLL_TARGET)"

default : DLL

.c.obj :
	$(CC) $(CFLAGS) -Fo$(OBJDIR)\$(*F).obj -c $(SRCDIR)\$(*F).c

.cpp.obj :
	$(CC) $(CFLAGS) -Fo$(OBJDIR)\$(*F).obj -c $(SRCDIR)\$(*F).cpp

.rc.res:
	rc.exe $(RSC_PROJ) /fo$(*F).res $(*F).rc

$(OUTDIR)\$(DLL_TARGET): $(LINK_OBJS)
    $(LINK) $(LINK_FLAGS)  -out:"$(OUTDIR)\$(*F).dll" $(LINK_OBJS)

DLL : OUTDIR CLEAN $(OUTDIR)\$(DLL_TARGET)
